#include <xc.h>
#include <stdint.h>                     // uint8_t def

#include "system.h"
#include "user.h"
#include "BD62xx.h"

//  Mode = A    ->  En mode In/In
// FIN RIN |  OUT
//  0   0  |  Z   Z       Roue libre
// PWM  0  |  1  PWM      Avant
//  0  PWM | PWM  1       Arriere
//  1   1  |  0   0       Frein

/**
 * @brief variable vitesse comprise entre -200 et +200
 * @param vit_gau
 * @param vit_dro
 */
void Moteurs(int16_t vit_gau, int16_t vit_dro)
{
//  Moteur Gauche
//  Mode acclration si dpart de 0
    
    if(vit_gau > 100)
    {
        CCPR1L = 100; 
        CCPR2L = 0;
    }
//    else if (vit_gau < -50)
//    {
//        CCPR1L = 50;
//        CCPR2L = 0;
//    }      
    if(vit_gau > 10)  // Moteur gauche vers l'avant
    {
        CCPR1L = (uint8_t)vit_gau;
        CCPR2L = 0;
    }
    else if(vit_gau < -10)  // Moteur gauche vers l'avant
    {
        CCPR2L = (uint8_t)-vit_gau;
        CCPR1L = 0;
    }
    else                    // Arret moteur gauche
    {
        CCPR1L = 200;
        CCPR2L = 200;
    }    
//  Moteur Droit 

    if(vit_dro > 100)
    {
        CCPR3L = 100; 
        CCPR4L = 0;
    }
//    else if (vit_dro < -50)
//    {
//        CCPR2L = 50;
//    }      
    if(vit_dro > 10)  // Moteur droit vers l'avant
    {
        CCPR3L = (uint8_t)vit_dro;
        CCPR4L = 0;
    }
    else if(vit_dro < -10)  // Moteur droit vers l'avant
    {
        CCPR3L = 0;
        CCPR4L = (uint8_t)-vit_dro;
    }
    else                    // Arret moteur droit
    {
        CCPR3L = 200; 
        CCPR4L = 200;
    }   
}