/******************************************************************************/
/*Files to Include                                                            */
/******************************************************************************/

#include <xc.h>             /* XC8 General Include File */
#include <stdint.h>         /* For uint8_t definition */
//#include <stdbool.h>        /* For true/false definition */
#include <stdio.h>
//#include <stdlib.h>
#include <string.h>

#include "system.h"
#include "interrupts.h"

/******************************************************************************/
/* Interrupt Routines                                                         */
/******************************************************************************/

/* High-priority service */

void __interrupt(high_priority) high_isr(void)
{
    /* TODO Placer ici le code pour les Interruptions  Haute Priorit. */

    /* Determine quel drapeau (Flag) a dclench l'interruption */
    if(CCP5IF)                  // Pour gnrer des sons sur Timer 5
    {
        CCP5IF = 0;
        TMR5 = 0;
    }
//    if(TMR1IF)                // Dbordement Timer 1
//    {
//        TMR1IF = 0;
//    }
    else if(INT0IF)
    {
        INT0IE = 0;             // Disable INT0 Interrupt
        if(INTEDG0)           // If ECHO is HIGH
        {
            TMR1ON = 1;         // Start Timer
            INTEDG0 = 0;        // Front descendant
            INT0IE = 1;
        }
        else           // If ECHO is LOW
        {
            TMR1ON = 0;         // Stop Timer
        }
        INT0IF = 0;
    }
    else
    {
        /* Unhandled interrupts */
    }
}

/* Low-priority interrupt routine */
char Rx_Data[10], Rx_Compt, Rx_Data_Ok = 0;
char tx_buffer[20];
uint8_t tx_i;
char RX2_Data[10], RX2_Compt, RX2_Data_Ok = 0;

void __interrupt(low_priority) low_isr(void)
{
    if (RC1IF)
    {
//        RC1IF = 0;
        Rx_Data[Rx_Compt] = RCREG;      // La lecture du registre remet  0 le flag RCIF
        if (Rx_Data[Rx_Compt] == 0x0D || Rx_Data[Rx_Compt] == 0x0A)	// retour  la ligne - CR Carriage Return
        {
            Rx_Data[Rx_Compt] = '\0';
            Rx_Compt = 0;
            Rx_Data_Ok = 1;
        }
        else
            Rx_Compt++;

        if (Rx_Data[0] == 'C' & Rx_Data[1] == 'L' & Rx_Data[2] == 'R')
            asm("reset");
    }
    else if(TX1IF)       // Interruption pour envoi d'un caractre    
    {
        putch(tx_buffer[tx_i++]);
        if(tx_buffer[tx_i] == '\0')
            TX1IE = 0;           // Il n'y a plus de caractres  envoyer, on masque cette interruption
    }
    else if(RC2IF)
    {
//        RC2IF = 0;
        RX2_Data[RX2_Compt] = RCREG2;      // La lecture du registre remet  0 le flag RC2IF
        if (RX2_Data[RX2_Compt] == 0x0D || RX2_Data[RX2_Compt] == 0x0A || RX2_Data[RX2_Compt] == '*')	// retour  la ligne - CR Carriage Return
        {
            RX2_Data[RX2_Compt] = '\0';
            RX2_Compt = 0;
            RX2_Data_Ok = 1;
        }
        else
            RX2_Compt++;
    }
    else           // Autres Interruptions
    {

    }
}

uint8_t Rx_Data_Rdy(void)
{
    if(Rx_Data_Ok)
    {
        Rx_Data_Ok = 0;
        return 1;
    }  
    else
        return 0;
}

void Read_Rx_Data(char *rx_buffer)
{
    strcpy(rx_buffer,Rx_Data);
}

//uint8_t RX2_Data_Rdy(void)
//{
//    if(RX2_Data_Ok)
//    {
//        RX2_Data_Ok = 0;
//        return 1;
//    }  
//    else
//        return 0;
//}

//void Read_RX2_Data(char *rx_buffer)
//{
//    strcpy(rx_buffer,RX2_Data);
//}
//
//void Affiche_Texte(char *tx_tab)
//{
//    if(TX1IE == 0)
//    {
//        strcpy(tx_buffer,tx_tab);
//        tx_i = 1;
//        putch(tx_buffer[0]);
//        TX1IE = 1;
//    }
//}
//===============================================



