/* 
 * File:   line.h
 * Author: Fred Giamarchi
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef LINE_H
#define	LINE_H

struct{ 
    uint8_t val;        // valeur mesure
    uint8_t min;        // valeur minimale
    uint8_t corr;        // valeur corrige
    uint8_t max;        // valeur maximale
    uint8_t delta;
}capteur[5];

void Init_Ligne(void);

void Lecture_Ligne(void);
void Line_Calibrate(void);
uint8_t Get_Capt_Corr(uint8_t select);
int16_t Get_Pos(void);
uint16_t Get_Somme(void);
void Print_Ligne(uint8_t entite);

void Line_Eeprom_Write(void);
void Line_Eeprom_Read(void);
unsigned char Eeprom18_Read(unsigned int adresse);
void Eeprom18_Write(unsigned int adresse, unsigned char valeur);

uint8_t Fonct_Stop(void);

#endif	/* LINE_H */

