/* 
 * File:   main.c
 * Author: fgiamarchi
 *
 * Created on 21 oct 2024, 00:00
 *      Robot Labyrinthe Ligne          Tournoi National Robotique 2025
 * 
 *  Test des moteurs                    Ok
 *  Test des entres analogiques        En cours
 */
//==============================================================================
#include <xc.h>
#include <stdio.h>                      // printf
#include <stdlib.h>
#include <stdint.h>                     // uint8_t def
#include <string.h>

#include "system.h"
#include "user.h"
#include "interrupts.h"
#include "BD62xx.h"
#include "line.h"
//==============================================================================
uint8_t etat;
uint16_t compteur;
char rx_command[10], command;
int8_t data;

int16_t erreur, erreur_old;
uint8_t kp, ki, kd;
int16_t pid, integral;
int16_t vit_ga, vit_dr;
uint8_t vit_max;
//==============================================================================
void main(void)
{
    Init_System();
    etat = 0;
    compteur = 0;
    Set_Coeur(12,250);      // 1 flash par seconde
    
    __delay_ms(100);      // Tempo ncessaire pour afficher le texte suivant
    PutString("RLL 2025 : Tests\r\n");
    
//==============================================================================    
    while(1)
    {
        Synchronisation();      //  4ms
        compteur++;
        Coeur_Qui_Bat();
//==============================================================================
//  Initialisation des paramtres du robot        
        switch(etat)
        {
            case 0:
                if(Appui_BP())
                {
                    etat++;
                    compteur = 0;
                    PutString("RLL 2025 : Test Capteurs\r\n");
                    Set_Coeur(125,250);
                }
                break;
//==============================================================================
            case 1:
                Lecture_Ligne();
                if(compteur == 50)
                {
                    compteur = 0;
                    Print_Ligne(0);
                }
                
                
                if(Appui_BP())
                {
                    etat = 100;
                }
                break;
//==============================================================================
            case 2:

                break;
//==============================================================================  
            case 3:

                break;
//==============================================================================   
            case 4:

                break;
//==============================================================================   
            case 5:


                break;
//==============================================================================   
            default:
                etat = 0;
                compteur = 0;
                break;
        }    
//==============================================================================        
//  Gestion des commandes reues par le port srie UART1
//        if(Rx_Data_Rdy() == 1 )
//        {
//            Read_Rx_Data(rx_command);
//            if((rx_command[0] == '$') && (rx_command[1] > 0x40) && (rx_command[1] < 0x5B))
//            {   // Commande avec lettre majuscule
//                command = rx_command[1];
//                rx_command[0] = '0';
//                rx_command[1] = '0';
//                if(rx_command[2] == '-')
//                {
//                    rx_command[2] = '0';
//                    data = -atoi(rx_command);
//                }
//                else
//                    data = atoi(rx_command); 
//                
//                printf("#%c%d\r\n",command+0x20,data);          // Rponse
//                compteur = 0;
//            }
//            else
//                Affiche_Texte("Err Syntax\r\n");
//        }
//==============================================================================
//  Gestion des commandes reues par le port srie UART2
//        if(RX2_Data_Rdy() == 1 )
//        {
//            Read_RX2_Data(rx_command);
//            if((rx_command[0] == '$') && (rx_command[1] > 0x40) && (rx_command[1] < 0x5B))
//            {   // Commande avec lettre majuscule
//                command = rx_command[1];
//                rx_command[0] = '0';
//                rx_command[1] = '0';
//                if(rx_command[2] == '-')
//                {
//                    rx_command[2] = '0';
//                    data = -atoi(rx_command);
//                }
//                else
//                    data = atoi(rx_command); 
//                
//                UART2_Putch('#');
//                UART2_Putch(command + 0x20);
//                UART2_Printf(data);
//                UART2_PutString("\r\n");
//                compteur = 0;
//            }
//            else
//                Affiche_Texte("Err Syntax\r\n");
//        }
//==============================================================================
    }   // Fin de la boucle while(1)
}   // Fin de la boucle main
//==============================================================================

