#include <xc.h>
#include <stdint.h>                     // uint8_t def

#include "system.h"
#include "user.h"
#include "note.h"

//==============================================================================
//  Appui BP -> 880Hz       Son correct
//  


void delay_ms(uint16_t milliseconds)
{
   while(milliseconds > 0)
   {
        milliseconds--;
        __delay_us(990);
   }
}
/**
 * Jouer une note
 * @param freq  en Hz
 * @param duree en ms
 */
void Play_Note(uint16_t freq, uint16_t duree)
{
    if((freq > 219) && (freq < 3001))
    {
        CCPR5 = 1000000/freq;           // Conversion en s
        T5CONbits.TMR5ON = 1;           // Timer5 Actif
        CCP5IE = 1;
    }
    else
    {
        T5CONbits.TMR5ON = 0;           // Timer5 Bloqu
        CCP5IE = 0;
    }
    
    delay_ms(duree);
    T5CONbits.TMR5ON = 0;           // Timer5 Bloqu
    CCP5IE = 0;
}

void Melodie_0(void)
{
struct note *n;

		n = &(song[0]);
		while (n->note_val)
        {
			Play_Note(n->note_val, n->dur);
			delay_ms(1);       //pause entre les notes
			n++;
        }
}