/* 
 * File:                note.h
 * Author:              F. G.
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef NOTE_H
#define	NOTE_H

#include <xc.h> // include processor files - each processor file is guarded.  

//==============================================================
//	Note de musique
//==============================================================
uint16_t const Note_1 [15] = {
	262, 294, 330, 349, 392, 440, 494,		
	523, 587, 659, 698, 784, 880, 988,
    000    };
//	Do   R   Mi   Fa   Sol  La   Si
//  C1   D1   E1   F1   G1   A1   B1
//  C2   D2   E2   F2   G2   A2   B2

#define _Do 0
#define _Re 1
#define _Mi 2
#define _Fa 3
#define _Sol 4
#define _La 5
#define _Si 6
#define Do 7
#define Re 8
#define Mi 9
#define Fa 10
#define Sol 11
#define La 12
#define Si 13
#define Do_ 14

#define A3  220
#define AS3 233
#define B3  247
#define C4  262
#define CS4 277
#define D4  294
#define DS4 311
#define E4  330
#define F4  349
#define FS4 370
#define G4  392
#define GS4 415
#define A4  440
#define AS4 466
#define B4  494
#define C5  523
#define CS5 554
#define D5  587
#define DS5 622
#define E5  659
#define F5  698
#define FS5 740
#define G5  784
#define GS5 831
#define A5  880
#define AS5 932
#define B5  988
#define C6  1047
#define CS6 1109
#define D6  1175
#define DS6 1245
#define E6  1319
#define F6  1397
#define FS6 1480
#define G6  1568
#define GS6 1661
#define A6  1760
#define AS6 1865
#define B6  1976
#define C7  2093
#define CS7 2217
#define D7  2349
#define DS7 2489
#define E7  2637
#define F7  2794
#define FS7 2960

struct note {
	uint16_t	note_val,	// note 
                dur;		// duration 
	} song[] = {
//	{ G1, 200 }, { G1, 200 }, { D2, 200 }, { D2, 200 },
//	{ E2, 200 }, { E2, 200 }, { D2, 400 },
//	{ C2, 200 }, { C2, 200 }, { B1, 200 }, { B1, 200 },
//	{ A1, 200 }, { A1, 200 }, { G1, 400 },
//	{ D2, 200 }, { D2, 200 }, { C2, 200 }, { C2, 200 },
//	{ B1, 200 }, { B1, 200 }, { A1, 400 },
//	{ D2, 200 }, { D2, 200 }, { C2, 200 }, { C2, 200 },
//	{ B1, 200 }, { B1, 200 }, { A1, 400 },
//	{ G1, 200 }, { G1, 200 }, { D2, 200 }, { D2, 200 },
//	{ E2, 200 }, { E2, 200 }, { D2, 400 },
//	{ C2, 200 }, { C2, 200 }, { B1, 200 }, { B1, 200 },
//	{ A1, 200 }, { A1, 200 }, { G1, 400 }, { 0, 0}
    { A4, 128 }, { G4, 128 }, { E4, 128 }, { C4, 128 },
	{ D4, 128 }, { B4, 128 }, { F4, 128 },
	{ C5, 128 }, { A4, 128 }, { G4, 128 }, { E4, 128 },
	{ C4, 128 }, { D4, 128 }, { B4, 128 },
//	{ Fa, 128 }, { Do_, 128 }, { D2, 21 }, { D2, 21 },
	{ C5, 128 }, { 0, 0}
};
    



// La : 440 Hz -> PR2 = 141 -> setup_timer_2(T2_DIV_BY_16, 141, 1);


void delay_ms(uint16_t milliseconds);
void Play_Note(uint16_t freq, uint16_t duree);
void Melodie_0(void);

#endif	/* NOTE_H */

// R2D2
//A7:G7:E7:C7:D7:B7:F7:C8:A7:G7:E7:C7:D7:B7:F7:C8

