/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef OLEDd_H
#define	OLEDd_H

#define OLED_H 64
#define OLED_L 128

#define SSD1306_I2C_ADDRESS   0x78

#define OLED_MEMORYMODE           0x20
#define SSD1306_COLUMNADDR        0x21
#define SSD1306_PAGEADDR          0x22
#define OLED_SETCONTRAST          0x81
#define OLED_CHARGEPUMP           0x8D
#define OLED_SEGREMAP             0xA0
#define OLED_DISPLAYALLON_RESUME  0xA4
#define SSD1306_DISPLAYALLON      0xA5       // Not used
#define OLED_NORMALDISPLAY        0xA6
#define SSD1306_INVERTDISPLAY_    0xA7
#define OLED_SETMULTIPLEX         0xA8
#define OLED_DISPLAYOFF           0xAE
#define OLED_DISPLAYON            0xAF
#define SSD1306_COMSCANINC        0xC0       // Not used
#define OLED_COMSCANDEC           0xC8
#define OLED_SETDISPLAYOFFSET     0xD3
#define OLED_SETDISPLAYCLOCKDIV   0xD5
#define OLED_SETPRECHARGE         0xD9
#define OLED_SETCOMPINS           0xDA
#define OLED_SETVCOMDETECT        0xDB

#define OLED_SETSTARTLINE         0x40
// Scrolling define
#define OLED_DEACTIVATE_SCROLL    0x2E
#define OLED_ACTIVATE_SCROLL      0x2F

void OLED_Command(uint8_t temp);
//void OLED_Data(uint8_t temp);
void OLED_Init(void);
void OLED_Display(void);
void OLED_ClearDisplay(void);
void OLED_XY(uint8_t colonne, uint8_t ligne);
void OLED_PutChar( char ch );
void OLED_Clear(void);
void OLED_Write_String(char *s);
void OLED_Write_Integer(uint16_t i);
//void OLED_Write_Float(float f);
void OLED_Set_Pixel(uint8_t x, uint8_t y);
//void OLED_Clear_Pixel(uint8_t x, uint8_t y);

#define OLED_swap(a, b) { uint8_t t = a; a = b; b = t; }
void OLED_Ligne(uint8_t x0, uint8_t y0, uint8_t x1, uint8_t y1);
void OLED_DrawFastHLine(uint8_t x, uint8_t y, uint8_t w);
void OLED_DrawFastVLine(uint8_t x, uint8_t y, uint8_t h);
void OLED_DrawRect(uint8_t x, uint8_t y, uint8_t w, uint8_t h);
void OLED_Bar_Graph(uint8_t value, uint8_t pos);
//void testdrawrect(void);

//  Fonctions RSL
void Aff_Logo(void);
void Oled_Menu(uint8_t num);

#endif	/* OLED_H */

