/* 
 * File:   
 * Author: 
 * Comments:
 * Revision history: 
 */

// This is a guard condition so that contents of this file are not included
// more than once.  
#ifndef SYSTEM_H
#define	SYSTEM_H

#define SYS_FREQ    64000000L
#define FCY         SYS_FREQ/4
#define _XTAL_FREQ  SYS_FREQ        // Utilis par la fonction __delay_ms

#define DIR_DEL_VERTE TRISAbits.TRISA7
#define DEL_VERTE LATAbits.LATA7
#define DIR_DEL_ROUGE TRISAbits.TRISA6
#define DEL_ROUGE LATAbits.LATA6

#define DIR_BP TRISBbits.TRISB4
#define BP PORTBbits.RB4

#define TMR0_PER    4000L			// Periode d'interruption en 1s
#define TMR0_Err    14L             // Erreur de Latence
#define TMR0_PRE    0b011           // Prescaler 1/16    -> tcycle = 62,5ns
#define TMR0_VALUE  0xFFFF-TMR0_PER+TMR0_Err

#define DIR_SENS_A1 TRISBbits.TRISB0
#define SENS_A1 LATBbits.LATB0
#define DIR_SENS_A2 TRISBbits.TRISB3
#define SENS_A2 LATBbits.LATB3

#define DIR_SENS_B1 TRISBbits.TRISB5
#define SENS_B1 LATBbits.LATB5
#define DIR_SENS_B2 TRISCbits.TRISC2
#define SENS_B2 LATCbits.LATC2

//#define DIR_PIEZZO TRISAbits.TRISA4
//
//#define DIR_I2C_SCL TRISCbits.TRISC3
//#define DIR_I2C_SDA TRISCbits.TRISC4

void Init_System(void);
void putch(unsigned char caract);
void PutString(const char *chaine);

//uint16_t Encodeur_T1(void);
//uint16_t Encodeur_T3(void);

void Sel_Canal_ADC(uint8_t canal);
uint8_t Read_ADC_8b(void);
//uint16_t Read_ADC_10b(void);

#endif	/* SYSTEM_H */

