#include <xc.h>
#include <stdint.h>                     // uint8_t def
#include <stdio.h>                      // printf
#include <stdlib.h>
#include <string.h>

#include "system.h"
#include "user.h"
#include "BD62xx.h"

/*  Fonction de synchronisation de la boucle infinie dans le fichier main.c */
void Synchronisation(void)
{
    while (!INTCONbits.TMR0IF);     // Attente dbordement du Timer0
    TMR0 = TMR0_VALUE;              // Prchargement du Timer0
    INTCONbits.TMR0IF = 0;          // Effacement du "flag" du Timer0
}
/*******************************************************************************
*   Fonction Coeur qui bat
*******************************************************************************/
uint16_t coeur_cmpt;
uint8_t coeur_etat;
uint16_t coeur_temps_haut;    // dure on en 4ms
uint16_t coeur_per;     // periode en 4ms

void Coeur_Qui_Bat(void)
{
    coeur_cmpt++;
    switch(coeur_etat)
    {
        case 0:
            DEL_VERTE = 1;
            if(coeur_cmpt == coeur_temps_haut)
                coeur_etat = 1;
            break;
        case 1:
            DEL_VERTE = 0;
            if(coeur_cmpt == coeur_per)
            {
                coeur_cmpt = 0;
                coeur_etat = 0;
            }
            break;
        default:
            coeur_etat = 0;
            coeur_cmpt = 0;
            coeur_temps_haut = 12;
            coeur_per = 250;
            break;
    }
}
void Set_Coeur(uint16_t temps_haut, uint16_t periode)
{
    coeur_temps_haut = temps_haut;
    coeur_per = periode;
}
//==============================================================================
//  Test Appui Bouton Poussoir
uint8_t mem_bp = 0;
uint8_t Appui_BP(void)
{
uint8_t ret_val = 0;

    if (!BP && mem_bp)
    {
        mem_bp = 0;
        ret_val = 1;
    }
    if(BP)
    {
        mem_bp = 1;
    }
    return ret_val;
}
//==============================================================================
//void UART2_Putch (unsigned char _caract)
//{
//    while (!TX2IF);
//    TX2REG = _caract;
//}
//==============================================================================
//void UART2_PutString (const char *chaine)
//{
//    while ((*chaine) != 0)
//    {
//        UART2_Putch (*chaine);
//        if (*chaine == 10) 
//            putch(10);
//        if (*chaine == 13) 
//            putch(13);
//        chaine++;
//    }
//}
//==============================================================================
//char Text_BT[10];
//void UART2_Printf(int nombre)
//{
//    itoa(Text_BT,nombre,10);
//    UART2_PutString(Text_BT);
//}
//==============================================================================
/**
 * Mesure la tension de l'accu Lipo 2S
 * @return valeur en mV
 */
uint16_t Mesure_Accu(void)
{
uint16_t    mesure;

    Sel_Canal_ADC(10);
    mesure = Read_ADC_8b();
//    return mesure * 4.9 * 2;    // en mV 10bits
    return mesure*4;    // en 10mV 8bits (19.8mV * 2)
}
//==============================================================================
uint8_t Charge_Accu(void)
{
uint8_t    mesure;

    Sel_Canal_ADC(10);
    mesure = Read_ADC_8b();
    if(mesure > ACCU_SEUIL_BAS)
    {
        mesure = (uint8_t)(mesure - ACCU_SEUIL_BAS);
        mesure = (uint8_t)(mesure * ACCU_COEFF);
    }
    else
        mesure = 0;
    return mesure;    // en %
}
//==============================================================================
